package demo;

import java.io.*;
import java.util.List;
import org.jaxen.dom.*;

import org.w3c.dom.*;
import org.apache.xerces.parsers.DOMParser;

/** XPath sample on DOM */
public class Demo {

    public static void main( String[] args ) throws Throwable {
	String xmlFile = args[ 0 ];
	String xmlPath = args[ 1 ];

	// Parse the file
        DOMParser parser = new DOMParser();
        parser.parse( xmlFile );
        Document doc = parser.getDocument();

	// Root node
	Node root = doc.getDocumentElement();

	// Run the test file
	BufferedReader br = new BufferedReader( new FileReader( xmlPath ) );
	String xpath;

	long init = System.currentTimeMillis();

        while ( ( xpath = br.readLine() ) != null ) {
            if ( xpath.startsWith( "#" ) ) continue;
	    System.out.println( xpath );
	    System.out.println( "-------------------------------------" );

	    DOMXPath path = new DOMXPath( xpath );

	    try {
		List ns = path.selectNodes( root );
		if ( args.length <= 2 ) {
		    System.out.println(ns.size() + " node found :");
		    for (int i = 0; i < ns.size(); i++) {
			System.out.println(ns.get(i));
		    }
		}
	    } catch( Throwable th ) {
		th.printStackTrace();
	    }
	    System.out.println( "-------------------------------------" );
	}
	System.out.println( "Total = " + ( System.currentTimeMillis() - init ) );
    }
}
