package demo;

import java.io.*;
import com.japisoft.xpath.*;
import com.japisoft.xpath.kit.DOMKit;

import org.w3c.dom.*;
import org.apache.xerces.parsers.DOMParser;

/** XPath sample on DOM */
public class Demo {

    public static void main( String[] args ) throws Throwable {
	String xmlFile = args[ 0 ];
	String xmlPath = args[ 1 ];

	// Parse the file
        DOMParser parser = new DOMParser();
        parser.parse( xmlFile );
        Document doc = parser.getDocument();

	// Root node
	Node root = doc.getDocumentElement();

	// Run the test file
	BufferedReader br = new BufferedReader( new FileReader( xmlPath ) );
	String xpath;
	long init = System.currentTimeMillis();

        while ( ( xpath = br.readLine() ) != null ) {
            if ( xpath.startsWith( "#" ) ) continue;
	    System.out.println( xpath );
	    System.out.println( "-------------------------------------" );
	    XPath xp = new XPath( new DOMKit() );
            xp.addVariable( "var1", "Text for D" );
            xp.addNamespaceDeclaration( "test", "http://www.japisoft.com" );

	    try {
		xp.setReferenceNode( root );
		xp.setXPathExpression( xpath );
		Object o = xp.resolveAny();
		if ( args.length <= 2 ) {
		    if ( o instanceof NodeSet ) {
			NodeSet ns = ( NodeSet )o;
			System.out.println(ns.size() + " node found :");
			for (int i = 0; i < ns.size(); i++) {
			    System.out.println(ns.elementAt(i));
			}
		    } else
			System.out.println( "Non NodeSet : " + o );
		}
	    } catch( Throwable th ) {
		th.printStackTrace();
	    }
	    System.out.println( "-------------------------------------" );
	}
	System.out.println( "Total = " + ( System.currentTimeMillis() - init ) );
	System.exit( 0 );
    }
}
