package demo;

import java.io.*;
import com.japisoft.xpath.*;
import com.japisoft.xpath.kit.FastParserKit;

import com.japisoft.fastparser.*;
import com.japisoft.fastparser.node.*;

public class Demo {

    public static void main( String[] args ) throws Throwable {
	String xmlFile = args[ 0 ];
	String xmlPath = args[ 1 ];

	// Parse the file
	Parser p = new Parser();
	p.setInputStream( new FileInputStream( xmlFile ) );
	p.parse();

	// Root node
	SimpleNode root = ( SimpleNode )p.getDocument().getRoot();

	// Run the test file
	BufferedReader br = new BufferedReader( new FileReader( xmlPath ) );
	String xpath;
	long init = System.currentTimeMillis();

	while ( ( xpath = br.readLine() ) != null ) {
          if ( xpath.startsWith( "#" ) )
            continue;
	    System.out.println( xpath );
	    System.out.println( "-------------------------------------" );
	    XPath xp = new XPath( new FastParserKit() );
            xp.addVariable( "var1", "Text for D" );
            xp.addNamespaceDeclaration( "test", "http://www.japisoft.com" );

	    try {
		xp.setReferenceNode( root );
		xp.setXPathExpression( xpath );
		Object o = xp.resolveAny();
                if ( o instanceof NodeSet ) {
                  NodeSet ns = ( NodeSet )o;
                  System.out.println(ns.size() + " node found :");
                  for (int i = 0; i < ns.size(); i++) {
                    System.out.println(ns.elementAt(i));
                  }
                } else
                  System.out.println( "Non NodeSet : " + o );
	    } catch( Throwable th ) {
		th.printStackTrace();
	    }
	    System.out.println( "-------------------------------------" );
	}
	System.out.println( "Total = " + ( System.currentTimeMillis() - init ) );
	System.exit( 0 );
    }

}

